# read a 16-bit binary file.  First few points are header & should be dropped.

function z = zread16(filename)
    fid = fopen(filename, "r") ;
    z = fread (fid, Inf, "short") ' ;
    z = z([23:length(z)]);
    fclose(fid) ;
endfunction

function rr = zwrite16(array, filename)
    z = [ ...
82 73 70 70  106 49  1   0  87 65  86 69  102  109  116 32 ...
16  0  0  0  1    0  1   0  68 172  0  0  136 88  1  0 ...
 2  0 16  0  100 97  116 97 70 49   1  0 ...
    ];
    ln = 2*length(array)+36;
    z(5) = mod(ln, 256);
    z(6) = mod(floor(ln/256),255);
    z(7) = mod(floor(ln/(256*256)),255);
    z(8) = mod(floor(ln/(256*256*256)),255);
    ln = 2*length(array);
    z(41) = mod(ln, 256);
    z(42) = mod(floor(ln/256),255);
    z(43) = mod(floor(ln/(256*256)),255);
    z(44) = mod(floor(ln/(256*256*256)),255);
    fid = fopen(filename, "w") ;
    fwrite (fid, z, "uchar");
    fwrite (fid, array, "short");
    fclose(fid);
    rr=0;
endfunction

function [x2, filter] = zlpc(x, stn, w, nn)
    cov = zeros(nn, nn);

    for strike = 1:length(stn)
        
        for i = 1:nn
            for j = i:nn
                dot = x((stn(strike)-i:stn(strike)-i+w)) ...
                    * (x((stn(strike)-j:stn(strike)-j+w))');
                cov(i,j) += dot;
            endfor
        endfor
    endfor

    for i = 1:nn
        for j = i:nn
            cov(j,i) = cov(i,j);
        endfor
    endfor

    cinv = inverse(cov(2:nn,2:nn));
    a = -cinv * cov(2:nn, 1);
    filter = [1 a'];
    x2 = conv(filter, x);

#    [evec, b] = schur(cov);
#    diag(b)
#    [v, indx] = sort(diag(b));
#    a = evec(:, indx(1))';
##    a = evec(indx(1), :);
#    meansq0 = meansq(a)
##    a = a([length(a):-1:1]);
#    meansq0 = meansq(a)
#    x2 = conv(a, x);
    
    pow = 0;
    pow2 = 0;
    count = 0;
    for strike = 1:length(stn)
        pow += x((stn(strike)-1:stn(strike)-1+w)) ...
            * (x((stn(strike)-1:stn(strike)-1+w))');
        pow2 += x2((stn(strike)-1:stn(strike)-1+w)) ...
            * (x2((stn(strike)-1:stn(strike)-1+w))');
        count += w+1;
    endfor
    meansq = pow/count;
    meansq2 = pow2/count
    relative = sqrt(pow2/pow)
endfunction
